

cc.Class({
    extends: cc.Component,

    properties: {
        isEveryCall:{
            default:false,
            displayName:"是否更新",
            tooltip:"防止Zindex改动或者删除子节点后出现空白区域，如果是固定内容可不勾选"
        },
        isInit:{
            default:true,
            displayName:"是否初始化",
            tooltip:"不滑动的情况下初始一次可视化渲染，反之滑动后初始可视化渲染"
        },
        InitTime:{
            default:0.1,
            displayName:"初始化时间",
            tooltip:"在生成所有item之后调用初始化，具体数值根据具体情况而定，默认0.1,在DelayTime之后"
        },
        DelayTime:{
            default:0.1,
            displayName:"延迟时间",
            tooltip:"界面可能有移动或者缩放等动画，延迟动画完毕后后调用，避免初始范围错误，默认0.1"
        },
        isRange:{
            default:0,
            displayName:"上下浮动范围",
            tooltip:"默认子节点高度的50%最合适，避免出现空白区域，具体自调"
        },
        
    },

    // LIFE-CYCLE CALLBACKS:

     onLoad () {
        this.svBBoxRect=0
        this.parentNode=this.node.parent
        this.childrenCount=0
        this.childList=[]
     },

    start () {
        
        this.scheduleOnce(()=>{
            let svLeftBottomPoint = this.parentNode.parent.convertToWorldSpaceAR(
                cc.v2(
                    this.parentNode.x - this.parentNode.anchorX * this.parentNode.width,
                    this.parentNode.y - this.parentNode.anchorY * this.parentNode.height
                )
            );   
            this.svBBoxRect = cc.rect(svLeftBottomPoint.x, svLeftBottomPoint.y-this.isRange, this.parentNode.width, this.parentNode.height+this.isRange);
                // 求出 ScrollView 可视区域在世界坐标系中的矩形（碰撞盒）
           
            this.parentNode.parent.on("scrolling",this.onScrollingDrawCallOpt,this);//监听scrollview事件
            this.scheduleOnce(function(){
                if(this.isInit)
                    this.onScrollingDrawCallOpt()     
            },this.InitTime) 

            for (let i = 0; i < this.node.children.length; i++) {
                
                this.childList.push(this.node.children[i].zIndex)
            }
            this.childrenCount=this.node.children.length
            
        },this.DelayTime+0.1)

    },


    update (dt) {
        
        if(this.parentNode.parent.opacity===0||this.parentNode.parent.active===false)//判定ScrollView是否关闭
        {
            return
        }
        if(this.isEveryCall)
        {
            this.monitoringData()
        }
    },
    //实时监测数据
    monitoringData(){
        if(this.childrenCount!=this.node.children.length)
        {
            this.childrenCount=this.node.children.length
            this.onScrollingDrawCallOpt()
            return
        }
        if(this.childList!=this.tmpList())
        {
            this.childList=this.tmpList()
            this.onScrollingDrawCallOpt()
        }  
    },

    //临时对比数据
    tmpList(){
        let tt=[]
        for (let i = 0; i < this.node.children.length; i++) {
                
            tt.push(this.node.children[i].zIndex)
        }
        return tt
    },

    //回调
    onScrollingDrawCallOpt(event){
            
        // 遍历 ScrollView Content 内容节点的子节点
        for (let i = 0; i < this.node.children.length; i++) {
            const childNode = this.node.children[i];
            if (childNode == null) {
                return;
        }
        
        // 对每个子节点的包围盒做和 ScrollView 可视区域包围盒做碰撞判断
        // 如果相交了，那么就显示，否则就隐藏
        if (childNode.getBoundingBoxToWorld().intersects(this.svBBoxRect)) {
            if (childNode.opacity != 255) {
                childNode.opacity = 255;   
            }
        } else {
            if (childNode.opacity != 0) {
                childNode.opacity = 0;
            }
        }
            
    }
    },

});
